; poppad1.pb
; based on poppad1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "poppad1", main_caption.s = "PopPad1"
Global hinstance = GetModuleHandle_(#NULL)

#ID_EDIT = 1

Procedure main_callback(hwin, message, wparam, lparam)
    static hedit
    
    Select message
        Case #WM_SETFOCUS 
            SetFocus_(hedit)
        Case #WM_SIZE  
            MoveWindow_(hedit, 0, 0, LOWORD(lparam), HIWORD(lparam), #TRUE)
        Case #WM_COMMAND 
            If LOWORD(wparam) = #ID_EDIT
                If HIWORD(wparam) = #EN_ERRSPACE Or HIWORD(wparam) = #EN_MAXTEXT
                    MessageBox_(hwin, "Edit control out of space.", app_name, #MB_OK | #MB_ICONSTOP)
                EndIf 
            EndIf 
        Case #WM_CREATE
            hedit = CreateWindow_(@WC_EDIT,#NULL,#WS_CHILD | #WS_VISIBLE | #WS_HSCROLL | #WS_VSCROLL | #WS_BORDER | #ES_LEFT | #ES_MULTILINE | #ES_AUTOHSCROLL | #ES_AUTOVSCROLL,0,0,0,0,hwin,#ID_EDIT,hinstance,#NULL)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam