;
; HexCalc.pbi
;
Procedure show_number(hwin, number.q)
    Define s_hex.s = Hex(number) 

    SetDlgItemText_(hwin, #VK_ESCAPE, @s_hex)
EndProcedure

Procedure calc_it(first_num, operation, iNum)
    Select operation
        Case '=': ProcedureReturn iNum;
        Case '+': ProcedureReturn first_num +  iNum
        Case '-': ProcedureReturn first_num -  iNum
        Case '*': ProcedureReturn first_num *  iNum
        Case '&': ProcedureReturn first_num &  iNum
        Case '|': ProcedureReturn first_num |  iNum
        Case '!': ProcedureReturn first_num !  iNum
        Case '<': ProcedureReturn first_num << iNum
        Case '>': ProcedureReturn first_num >> iNum
        Case '/'
            If iNum
                ProcedureReturn first_num / iNum
            Else
                ProcedureReturn #MAXDWORD
            EndIf
        Case '%'
            If iNum
                ProcedureReturn first_num % iNum
            Else
                ProcedureReturn #MAXDWORD
            EndIf
        default : ProcedureReturn 0
    EndSelect
EndProcedure

