;   PopFont.pbi -- Popup Editor Font Functions
;

Define log_font.LOGFONT, hfont

Procedure pop_font_choose_font(hwnd)
    Shared log_font
    Define cf.CHOOSEFONT
    
    cf\lStructSize    = SizeOf(CHOOSEFONT)
    cf\hwndOwner     = hwnd
    cf\lpLogFont     = log_font
    cf\Flags        = #CF_INITTOLOGFONTSTRUCT | #CF_SCREENFONTS | #CF_EFFECTS
    
    ProcedureReturn ChooseFont_(cf)
EndProcedure

Procedure pop_font_initialize(hedit)
    Shared log_font, hfont
    GetObject_(GetStockObject_(#SYSTEM_FONT), SizeOf(LOGFONT), log_font)

    hfont = CreateFontIndirect_(log_font)
    SendMessage_(hedit, #WM_SETFONT, hfont, 0)
EndProcedure

Procedure pop_font_set_font(hedit)
    Shared log_font, hfont
    Define hfont_new, rect.RECT
    
    hfont_new = CreateFontIndirect_(log_font)
    SendMessage_(hedit, #WM_SETFONT, hfont_new, 0)
    DeleteObject_(hfont)
    hfont = hfont_new
    GetClientRect_(hedit, rect)
    InvalidateRect_(hedit, rect, #TRUE)
EndProcedure

Procedure pop_font_deinitialize()
    Shared hfont
    DeleteObject_(hfont)
EndProcedure
