;
; scramble.pb
; based on scramble.c by Charles Petzold, in PW5E
; WARNING: let this program finish before you try to do anything,
; otherwise you will get screen glitches.
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "scramble", main_caption.s = "The Window Text"
Global hinstance = GetModuleHandle_(#NULL)

#NUM = 300
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Dim iKeep(#NUM-1,3)
    Define hdc_screen, hdc_mem, width, height, hbitmap, hwin
    Define i, j, x1, y1, x2, y2
    
    hwin = GetDesktopWindow_()
    If LockWindowUpdate_(hwin)
        hdc_screen  = GetDCEx_(hwin, #NULL, #DCX_CACHE | #DCX_LOCKWINDOWUPDATE)
        hdc_mem  = CreateCompatibleDC_(hdc_screen)
        width     = GetSystemMetrics_(#SM_CXSCREEN) / 10
        height     = GetSystemMetrics_(#SM_CYSCREEN) / 10
        hbitmap = CreateCompatibleBitmap_(hdc_screen, width, height)
        
        SelectObject_(hdc_mem, hbitmap)
    
        For i = 0 To 1
            For j = 0  To #NUM-1
                If i = 0
                    x1 = width *(Random(9))  : iKeep(j, 0) = x1
                    y1 = height*(Random(9))  : iKeep(j, 1) = y1 
                    x2 = width *(Random(9))  : iKeep(j, 2) = x2 
                    y2 = height*(Random(9))  : iKeep(j, 3) = y2 
                Else
                    x1 = iKeep(#NUM - 1 - j, 0)
                    y1 = iKeep(#NUM - 1 - j, 1)
                    x2 = iKeep(#NUM - 1 - j, 2)
                    y2 = iKeep(#NUM - 1 - j, 3)
                EndIf 
                BitBlt_(hdc_mem,  0,  0, width, height, hdc_screen, x1, y1, #SRCCOPY)
                BitBlt_(hdc_screen, x1, y1, width, height, hdc_screen, x2, y2, #SRCCOPY)
                BitBlt_(hdc_screen, x2, y2, width, height, hdc_mem,  0,  0, #SRCCOPY)
                    
                Sleep_(10)
            Next j
        Next i
        DeleteDC_(hdc_mem)
        ReleaseDC_(hwin, hdc_screen)
        DeleteObject_(hbitmap)

        LockWindowUpdate_(#NULL)
    EndIf 
End #FALSE
