#IDM_EDIT_CUT = 40001
#IDM_EDIT_COPY = 40002
#IDM_EDIT_PASTE = 40003
#IDM_EDIT_DELETE = 40004


Procedure InvertBlock(hscreen, hwin, *beginpt.POINT, *endpt.POINT)
    Define hdc = GetDCEx_(hscreen, #NULL, #DCX_CACHE | #DCX_LOCKWINDOWUPDATE)
    ; prevent the originals from being modified
    Define pt_beg.POINT, pt_end.POINT
    CopyMemory(*beginpt, pt_beg, SizeOf(POINT))
    CopyMemory(*endpt, pt_end, SizeOf(POINT))

    ClientToScreen_(hwin, pt_beg)
    ClientToScreen_(hwin, pt_end)

    PatBlt_(hdc, pt_beg\x, pt_beg\y, pt_end\x - pt_beg\x, pt_end\y - pt_beg\y, #DSTINVERT)
    ReleaseDC_(hscreen, hdc)
EndProcedure 

Procedure CopyBitmap(hbmp_src)
    Define bitmap.BITMAP,  hbmp_dest, hdc_src, hdc_dest

    GetObject_(hbmp_src, SizeOf(BITMAP), bitmap)
    hbmp_dest = CreateBitmapIndirect_(bitmap)

    hdc_src = CreateCompatibleDC_(#NULL)
    hdc_dest = CreateCompatibleDC_(#NULL)

    SelectObject_(hdc_src, hbmp_src)
    SelectObject_(hdc_dest, hbmp_dest)

    BitBlt_(hdc_dest, 0, 0, bitmap\bmWidth, bitmap\bmHeight, hdc_src, 0, 0, #SRCCOPY)

    DeleteDC_(hdc_src)
    DeleteDC_(hdc_dest)

    ProcedureReturn hbmp_dest
EndProcedure 
