
Structure sys_mets
    flag.l
    name.s 
    desc.s
EndStructure

DataSection
    sys_metrics_data:
    Data.i #SM_CXSCREEN         : Data.s "SM_CXSCREEN", "Screen width in pixels"
    Data.i #SM_CYSCREEN         : Data.s "SM_CYSCREEN", "Screen height in pixels"
    Data.i #SM_CXVSCROLL        : Data.s "SM_CXVSCROLL", "Vertical scroll arrow width"
    Data.i #SM_CYHSCROLL        : Data.s "SM_CYHSCROLL", "Horizontal scroll arrow height"
    Data.i #SM_CYCAPTION        : Data.s "SM_CYCAPTION", "Caption bar height"
    Data.i #SM_CXBORDER         : Data.s "SM_CXBORDER", "Window border width"
    Data.i #SM_CYBORDER         : Data.s "SM_CYBORDER", "Window border height"
    Data.i #SM_CXFIXEDFRAME     : Data.s "SM_CXFIXEDFRAME", "Dialog window frame width"
    Data.i #SM_CYFIXEDFRAME     : Data.s "SM_CYFIXEDFRAME", "Dialog window frame height"
    Data.i #SM_CYVTHUMB         : Data.s "SM_CYVTHUMB", "Vertical scroll thumb height"
    Data.i #SM_CXHTHUMB         : Data.s "SM_CXHTHUMB", "Horizontal scroll thumb width"
    Data.i #SM_CXICON           : Data.s "SM_CXICON", "Icon width"
    Data.i #SM_CYICON           : Data.s "SM_CYICON", "Icon height"
    Data.i #SM_CXCURSOR         : Data.s "SM_CXCURSOR", "Cursor width"
    Data.i #SM_CYCURSOR         : Data.s "SM_CYCURSOR", "Cursor height"
    Data.i #SM_CYMENU           : Data.s "SM_CYMENU", "Menu bar height"
    Data.i #SM_CXFULLSCREEN     : Data.s "SM_CXFULLSCREEN", "Full screen client area width"
    Data.i #SM_CYFULLSCREEN     : Data.s "SM_CYFULLSCREEN", "Full screen client area height"
    Data.i #SM_CYKANJIWINDOW    : Data.s "SM_CYKANJIWINDOW", "Kanji window height"
    Data.i #SM_MOUSEPRESENT     : Data.s "SM_MOUSEPRESENT", "Mouse present flag"
    Data.i #SM_CYVSCROLL        : Data.s "SM_CYVSCROLL", "Vertical scroll arrow height"
    Data.i #SM_CXHSCROLL        : Data.s "SM_CXHSCROLL", "Horizontal scroll arrow width"
    Data.i #SM_DEBUG            : Data.s "SM_DEBUG", "Debug version flag"
    Data.i #SM_SWAPBUTTON       : Data.s "SM_SWAPBUTTON", "Mouse buttons swapped flag"
    Data.i #SM_CXMIN            : Data.s "SM_CXMIN", "Minimum window width"
    Data.i #SM_CYMIN            : Data.s "SM_CYMIN", "Minimum window height"
    Data.i #SM_CXSIZE           : Data.s "SM_CXSIZE", "Min/Max/Close button width"
    Data.i #SM_CYSIZE           : Data.s "SM_CYSIZE", "Min/Max/Close button height"
    Data.i #SM_CXSIZEFRAME      : Data.s "SM_CXSIZEFRAME", "Window sizing frame width"
    Data.i #SM_CYSIZEFRAME      : Data.s "SM_CYSIZEFRAME", "Window sizing frame height"
    Data.i #SM_CXMINTRACK       : Data.s "SM_CXMINTRACK", "Minimum window tracking width"
    Data.i #SM_CYMINTRACK       : Data.s "SM_CYMINTRACK", "Minimum window tracking height"
    Data.i #SM_CXDOUBLECLK      : Data.s "SM_CXDOUBLECLK", "Double click x tolerance"
    Data.i #SM_CYDOUBLECLK      : Data.s "SM_CYDOUBLECLK", "Double click y tolerance"
    Data.i #SM_CXICONSPACING    : Data.s "SM_CXICONSPACING", "Horizontal icon spacing"
    Data.i #SM_CYICONSPACING    : Data.s "SM_CYICONSPACING", "Vertical icon spacing"
    Data.i #SM_MENUDROPALIGNMENT: Data.s "SM_MENUDROPALIGNMENT", "Left or right menu drop"
    Data.i #SM_PENWINDOWS       : Data.s "SM_PENWINDOWS", "Pen extensions installed"
    Data.i #SM_DBCSENABLED      : Data.s "SM_DBCSENABLED", "Double-Byte Char Set enabled"
    Data.i #SM_CMOUSEBUTTONS    : Data.s "SM_CMOUSEBUTTONS", "Number of mouse buttons"
    Data.i #SM_SECURE           : Data.s "SM_SECURE", "Security present flag"
    Data.i #SM_CXEDGE           : Data.s "SM_CXEDGE", "3-D border width"
    Data.i #SM_CYEDGE           : Data.s "SM_CYEDGE", "3-D border height"
    Data.i #SM_CXMINSPACING     : Data.s "SM_CXMINSPACING", "Minimized window spacing width"
    Data.i #SM_CYMINSPACING     : Data.s "SM_CYMINSPACING", "Minimized window spacing height"
    Data.i #SM_CXSMICON         : Data.s "SM_CXSMICON", "Small icon width"
    Data.i #SM_CYSMICON         : Data.s "SM_CYSMICON", "Small icon height"
    Data.i #SM_CYSMCAPTION      : Data.s "SM_CYSMCAPTION", "Small caption height"
    Data.i #SM_CXSMSIZE         : Data.s "SM_CXSMSIZE", "Small caption button width"
    Data.i #SM_CYSMSIZE         : Data.s "SM_CYSMSIZE", "Small caption button height"
    Data.i #SM_CXMENUSIZE       : Data.s "SM_CXMENUSIZE", "Menu bar button width"
    Data.i #SM_CYMENUSIZE       : Data.s "SM_CYMENUSIZE", "Menu bar button height"
    Data.i #SM_ARRANGE          : Data.s "SM_ARRANGE", "How minimized buttons are arranged"
    Data.i #SM_CXMINIMIZED      : Data.s "SM_CXMINIMIZED", "Minimized window width"
    Data.i #SM_CYMINIMIZED      : Data.s "SM_CYMINIMIZED", "Minimized window height"
    Data.i #SM_CXMAXTRACK       : Data.s "SM_CXMAXTRACK", "Maximum draggable width"
    Data.i #SM_CYMAXTRACK       : Data.s "SM_CYMAXTRACK", "Maximum draggable height"
    Data.i #SM_CXMAXIMIZED      : Data.s "SM_CXMAXIMIZED", "Width of maximized window"
    Data.i #SM_CYMAXIMIZED      : Data.s "SM_CYMAXIMIZED", "Height of maximized window"
    Data.i #SM_NETWORK          : Data.s "SM_NETWORK", "Network present flag"
    Data.i #SM_CLEANBOOT        : Data.s "SM_CLEANBOOT", "How system was booted"
    Data.i #SM_CXDRAG           : Data.s "SM_CXDRAG", "Avoid drag x tolerance"
    Data.i #SM_CYDRAG           : Data.s "SM_CYDRAG", "Avoid drag y tolerance"
    Data.i #SM_SHOWSOUNDS       : Data.s "SM_SHOWSOUNDS", "Present sounds visually"
    Data.i #SM_CXMENUCHECK      : Data.s "SM_CXMENUCHECK", "Menu check-mark width"
    Data.i #SM_CYMENUCHECK      : Data.s "SM_CYMENUCHECK", "Menu check-mark height"
    Data.i #SM_SLOWMACHINE      : Data.s "SM_SLOWMACHINE", "Slow processor flag"
    Data.i #SM_MIDEASTENABLED   : Data.s "SM_MIDEASTENABLED", "Hebrew and Arabic enabled flag"
    Data.i #SM_MOUSEWHEELPRESENT: Data.s "SM_MOUSEWHEELPRESENT", "Mouse wheel present flag"
    Data.i #SM_XVIRTUALSCREEN   : Data.s "SM_XVIRTUALSCREEN", "Virtual screen x origin"
    Data.i #SM_YVIRTUALSCREEN   : Data.s "SM_YVIRTUALSCREEN", "Virtual screen y origin"
    Data.i #SM_CXVIRTUALSCREEN  : Data.s "SM_CXVIRTUALSCREEN", "Virtual screen width"
    Data.i #SM_CYVIRTUALSCREEN  : Data.s "SM_CYVIRTUALSCREEN", "Virtual screen height"
    Data.i #SM_CMONITORS        : Data.s "SM_CMONITORS", "Number of monitors"
    Data.i #SM_SAMEDISPLAYFORMAT: Data.s "SM_SAMEDISPLAYFORMAT", "Same color format flag"
EndDataSection
#NUMLINES = 75
Global Dim sys_metrics.sys_mets(#NUMLINES-1)
     
Restore sys_metrics_data
Define i
For i = 0 To #NUMLINES-1
    Read.i sys_metrics(i)\flag
    Read.s sys_metrics(i)\name
    Read.s sys_metrics(i)\desc
Next i
 
