;
; RandRect.pbi
;
Global lastTick
lastTick = ElapsedMilliseconds()
Procedure draw_rectangle(hwin)
    Define hbrush, hdc, rect.RECT

    If ElapsedMilliseconds()-lastTick < 20 ; slow things down a bit
        ProcedureReturn
    EndIf

    If client_width = 0 or client_height = 0
        ProcedureReturn
    EndIf

    SetRect_(rect, random(client_width-1), random(client_height-1), random(client_width-1), random(client_height-1))

    hbrush = CreateSolidBrush_(RGB(random(255), random(255), random(255)))

    hdc = GetDC_(hwin)
    FillRect_(hdc, rect, hbrush)
    ReleaseDC_(hwin, hdc)
    DeleteObject_(hbrush)

    lastTick = ElapsedMilliseconds()
EndProcedure
