;
; Environ.pbi
;
Procedure fill_list_box(hlistbox)
    Define length, *pvar_block.c, *pvar_beg.c, *pvar_end.c, var_name.s

    *pvar_block = GetEnvironmentStrings_()  ; Get pointer to environment block

    While PeekC(*pvar_block) <> 0
        If PeekC(*pvar_block) <> '='   ; Skip variable names beginning with '='
            *pvar_beg = *pvar_block        ; Beginning of variable name
            While PeekC(*pvar_block) <> '='  ; Scan until '='
                *pvar_block + SizeOf(CHAR)
            Wend
            *pvar_end = *pvar_block         ; Points to '=' sign
            *pvar_block + SizeOf(CHAR)
            length = (*pvar_end - *pvar_beg)/SizeOf(CHAR) ; Length of variable name

            ; Copy the variable name and append a zero.
            var_name = PeekS(*pvar_beg, length)

            ; Put the variable name in the list box
            SendMessage_(hlistbox, #LB_ADDSTRING, 0, @var_name)
        EndIf
        While PeekC(*pvar_block) <> 0  ; Scan until terminating zero
            *pvar_block + SizeOf(CHAR)
        Wend
        *pvar_block + SizeOf(CHAR)
    Wend
    FreeEnvironmentStrings_(*pvar_block)
EndProcedure
