; about1.pb
; based on about1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "about1", main_caption.s = "About Box Demo Program"
Global hinstance = GetModuleHandle_(#NULL)

#IDM_APP_ABOUT = 40001

Procedure about_callback(hdlg, message, wparam, lparam)
    Select message
        Case #WM_INITDIALOG
            ProcedureReturn #TRUE
        Case #WM_COMMAND
            Define id = LOWORD(wparam)
            Select id
                Case #IDOK, #IDCANCEL
                    EndDialog_(hdlg, 0)
                    ProcedureReturn #TRUE
            EndSelect
    EndSelect
    ProcedureReturn #FALSE
EndProcedure

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Define hdc
    
    Select message
        Case #WM_COMMAND
            Define id = LOWORD(wparam)
            Select id
                Case #IDM_APP_ABOUT 
                    DialogBox_(hinstance, @"AboutBox", hwin, @about_callback())
            EndSelect 
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(hinstance, @app_name)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam