#IDC_FILENAME = 1000
#IDM_FILE_NEW = 40001
#IDM_FILE_OPEN = 40002
#IDM_FILE_SAVE = 40003
#IDM_FILE_SAVE_AS = 40004
#IDM_FILE_PRINT = 40005
#IDM_APP_EXIT = 40006
#IDM_EDIT_UNDO = 40007
#IDM_EDIT_CUT = 40008
#IDM_EDIT_COPY = 40009
#IDM_EDIT_PASTE = 40010
#IDM_EDIT_CLEAR = 40011
#IDM_EDIT_SELECT_ALL = 40012
#IDM_SEARCH_FIND = 40013
#IDM_SEARCH_NEXT = 40014
#IDM_SEARCH_REPLACE = 40015
#IDM_FORMAT_FONT = 40016
#IDM_HELP = 40017
#IDM_APP_ABOUT = 40018


Procedure do_caption(hwin, fs_title_name.s)
    Define caption.s = app_name + " - " + fs_title_name
    If Len(fs_title_name) = 0
        caption + UNTITLED
    EndIf
    SetWindowText_(hwin, caption)
EndProcedure

Procedure ok_message(hwin, s_message.s)
    MessageBox_(hwin, s_message, app_name, #MB_OK | #MB_ICONEXCLAMATION)
EndProcedure

Procedure ask_about_save(hwin, fs_title_name.s)
    Define s_buffer.s = "Save current changes in " + fs_title_name
    If Len(fs_title_name) = 0
        s_buffer + UNTITLED
    EndIf
    s_buffer + "?"

    Define ret_val = MessageBox_(hwin, s_buffer, app_name, #MB_YESNOCANCEL | #MB_ICONQUESTION)

    If ret_val = #IDYES
        If Not SendMessage_(hwin, #WM_COMMAND, #IDM_FILE_SAVE, 0)
            ret_val = #IDCANCEL
        EndIf
    EndIf
    ProcedureReturn ret_val
EndProcedure

Procedure about_callback(hdlg, message, wparam, lparam)
    Select message
        Case #WM_INITDIALOG
            ProcedureReturn #TRUE
        Case #WM_COMMAND
            Select LOWORD(wparam)
                Case #IDOK
                    EndDialog_(hdlg, 0)
                    ProcedureReturn #TRUE
            EndSelect
    EndSelect
    ProcedureReturn #FALSE
EndProcedure

