#IDM_FILE_OPEN = 40001
#IDM_SHOW_NORMAL = 40002
#IDM_SHOW_CENTER = 40003
#IDM_SHOW_STRETCH = 40004
#IDM_SHOW_ISOSTRETCH = 40005
#IDM_FILE_PRINT = 40006
#IDM_EDIT_COPY = 40007
#IDM_EDIT_CUT = 40008
#IDM_EDIT_DELETE = 40009
#IDM_FILE_SAVE = 40010


Procedure show_dib(hdc, *bmi.BITMAPINFO, *bits, dib_width, dib_height, client_width, client_height, show_type)
    Select show_type
        Case #IDM_SHOW_NORMAL
            ProcedureReturn SetDIBitsToDevice_(hdc, 0, 0, dib_width, dib_height, 0, 0, 0, dib_height, *bits, *bmi, #DIB_RGB_COLORS)
        Case #IDM_SHOW_CENTER
            ProcedureReturn SetDIBitsToDevice_(hdc,(client_width - dib_width) / 2, (client_height - dib_height) / 2, dib_width, dib_height, 0, 0, 0, dib_height, *bits, *bmi, #DIB_RGB_COLORS)
        Case #IDM_SHOW_STRETCH
            SetStretchBltMode_(hdc, #COLORONCOLOR)
    
            ProcedureReturn StretchDIBits_(hdc, 0, 0, client_width, client_height, 0, 0, dib_width, dib_height, *bits, *bmi, #DIB_RGB_COLORS, #SRCCOPY)
        Case #IDM_SHOW_ISOSTRETCH
            SetStretchBltMode_(hdc, #COLORONCOLOR)
            SetMapMode_(hdc, #MM_ISOTROPIC)
            SetWindowExtEx_(hdc, dib_width, dib_height, #NULL)
            SetViewportExtEx_(hdc, client_width, client_height, #NULL)
            SetWindowOrgEx_(hdc, dib_width / 2, dib_height / 2, #NULL)
            SetViewportOrgEx_(hdc, client_width / 2, client_height / 2, #NULL)
    
            ProcedureReturn StretchDIBits_(hdc, 0, 0, dib_width, dib_height, 0, 0, dib_width, dib_height, *bits, *bmi, #DIB_RGB_COLORS, #SRCCOPY)
    
        Default
            ProcedureReturn 0
    EndSelect    
EndProcedure 
